(defun c:ctan ()
(setq p1 (getpoint "\npoint to first circle: "))
(setq p2 (getpoint "\npoint to second circle: "))
(setq p1 (osnap p1 "near"))
(setq p2 (osnap p2 "near"))
(setq c1 (osnap p1 "cen"))
(setq p4 (osnap p2 "cen"))
(setq p5 (distance c1 p4))
(setq a1 (angle c1 p4))
(setq p1a (distance p1 c1))
(setq a2 (distance p2 p4))
(setq p3 (polar c1 a1 (* (/ p1a a2) (/ p5 (1+ (/ p1a a2))))))
 (command "line" p3 "tan" p1 "")
 (command "line" p3 "tan" p2 "")
)
;
;  C:CTAN draws "cross tangent" lines (tangents which cross
;the line between the circle centers) between two circles
;of any radius.  The tangent line is actually drawn in two
;line segments.
;
;  C:CTAN prompts the user to input two points on two circles.
;The points should be approximate "best guess" points showing
;the direction of the desired tangent line.  C:CTAN will
;not work with concentric circles.
;
;  C:CTAN works on the geometric principle that the ratio of
;the radii of two circles is equal to the ratio of the distances
;of the segments from the circle centers to the point where
;the tangent lines intersect the line between the circle
;centers.
;
;  See the function C:STAN to draw tangents between circles
;which do not intersect the line between the circle centers.
