;==========================================================
;
;   Advanced AutoLISP Concepts
;
;   July 1988    Bill Kramer
;   Kramer Consulting, Inc.
;
;   LISTING 1
;
;   Utility routines for entity and selection set
;   manipulation.
;     ENTHERE  returns entity name at a point.
;     SSGETP   returns selection set built using only 
;              direct entity selections.
;
;--------1---------2---------3---------4---------5---------6
;
(defun ENTHERE (PNT / SSE)
   (setq SSE (ssget PNT))
   (cond
      ((null SSE) nil)
      (t (ssname SSE 0))))
;                 
(defun SSGETP ();/ SSP P1 OPTS EN TMP)
   (setq SSP (ssadd) TMP "Select:" OPTS "R U")
   (initget 0 OPTS)
    (while (setq P1 (getpoint TMP))
        (cond
          ((= P1 "R") (setq TMP "Remove:" OPTS "A"))
          ((= P1 "A") (setq TMP "Select:" OPTS "R U"))
          ((= P1 "U")
             (ssdel (ssname SSP (1- (sslength SSP))) SSP))
          (t
             (setq EN (enthere P1))
             (cond
               ((and EN (= TMP "Remove:")) (ssdel EN SSP))
               ((and EN (= TMP "Select:")) (ssadd EN SSP))
               (t (prompt "\nNo entity found!  ")))))
        (initget 0 OPTS)
     )
     (setq SSP SSP)
)





;--------1---------2---------3---------4---------5---------6
;
;   LISTING 2
;
;   STEELBOM searches drawing for all lines on layer 
;   "STEEL_CL".  Each of the lines are then inspected
;   to determine the length.  If the length fits a set
;   of known lengths, an associated counter is incremented.
;   Otherwise the line is changed to layer "FIXME" for
;   correction.
;
;--------1---------2---------3---------4---------5---------6
(defun C:STEELBOM ()
   (setq SS1 (ssget "X" '((0 . "LINE") (8 . "STEEL_CL"))))
   (print (sslength SS1))
   (prompt " entities found")
   (setq CNTLIST '((12 . 0)(24 . 0)(48 . 0)(96 . 0))
         CNT -1
         CNTDEL 0)
   (repeat (sslength SS1)
      (setq EL (entget (ssname SS1 (setq CNT (1+ CNT))))
            DS (fix (+ 0.000001
                    (distance (cdr (assoc 10 EL)) (cdr (assoc 11 EL))))))
      (cond
         ((setq AA (assoc DS CNTLIST))
             (setq CNTLIST (subst (cons DS (1+ (cdr AA))) AA CNTLIST)))
         (t (setq EL (subst (cons 8 "FIXME") (assoc 8 EL) EL)
                  CNTDEL (1+ CNTDEL))
            (entmod EL))))
   (prompt "\n(Len   Cnt)")
   (foreach MBR CNTLIST
       (print MBR)
   )
   (print CNTDEL)
   (prompt " entities changed to layer FIXME!")
   (princ)
)
