;                             Bullock and Associates
;                                 P.O. Box 50636
;                              Nashville, TN  37205
;                                   615-352-0571

;                              AutoCAD consultants.

;Why RECURSE?  RECURSE is short for Recursive.  The output of this program
;creates a "recursive loop" between AutoCAD and MSDOS.

;RECURSE works by automatically executing any "Script" file, on any given
;drawing, disk full of drawings, or wild card directory of drawings.

;                        General Notes
;                        -------------

;   RECURSE is easy to use.  You simply use the MSDOS pipe command to
;   pipe a directory of drawings into a file called "drawing.dir".

;     Ex.       DIR *.DWG>drawing.dir

;   Then load RECURSE.  Recurse is self-executing.  When you load the
;   program it asks you for the name of the "Script-file" you wish to
;   recurse.  Enter the script-file name and return.  The program
;   automaticaly creates a batch file called "GALAXY.BAT" in your
;   default directory.  Exit AutoCAD change to the directory where
;   "GALAXY.BAT" and your drawing files lie.  Type in GALAXY and hit
;   return.

; Why GALAXY? I figure if global changes are changes made throughout
; a single drawing, then changes made in several drawings is appropriately
; labeled GALAXY.


;Amazing, AutoCAD will now enter the drawing editor with the first
;drawing in your directory executing the script-file at the same time.
;It will repeat this process until it reaches the last drawing in your
;directory.

;There is further documentation and hints at the end of the program.


(setq scr (getstring "What SCRIPT-FILE do you want to RECURSE ? "))

(defun c:a ()
(setq file1 (open "drawing.dir" "r" )) ;opens piped directory
        (start))

(defun record (a fname scr)
        (strcat a " " fname " " scr "\n")
)


(defun start ()
(setq file2 (open "galaxy.bat" "w" ))
(read-line file1)   ;these lines scroll past the top lines in
(read-line file1)   ;the piped directory.
(read-line file1)
(read-line file1)
(getrecord "acad" (read-line file1) scr))

(defun getrecord ( a  fline scr)
        (cond                  ;sets the conditions to close file2
                ( (eq  fline nil) (close file2))
                ( (eq (substr fline 1 2) "  ") (close file2))
                (t      (princ
                        (record a (substr fline 1 8) scr)
                         file2)
                        (getrecord "acad" (read-line file1) scr))
                ))


(defun stop ()
(close file2))

(c:a)

;                      HINTS on writing a RECURSable Script
;                    ------------------------------------------
;
;      1. The first line must contain only the numeral 2.
;
;      2. The second line must be left blank.
;
;      3. There is only one way to end a RECURSEable script and save
;         your changes.  The final three lines of your script must
;         contain the sequence "END", the numeral "0" and the last
;         line--a cariage return, in other words; left blank.
;
;NOTE: What lies between the begining and the end of the "Script" is
;limited only by the imagination.  Remember that "Script" files can
;load AutoLISP programs.
;
;If you have trouble executing "GALAXY.BAT" make sure that you have set
;your path so that your drawings, your ACAD.EXE and your script files
;are included.  If you use a batch file named ACAD.BAT to start AutoCAD
;make sure that it is NOT in the path.
;
;Special thanks to Charles Dickens.