(defun c:stan ()
(setq p1 (getpoint "\npoint to first circle: "))
(setq p2 (getpoint "\npoint to second circle: "))
(setq p1 (osnap p1 "near"))
(setq p2 (osnap p2 "near"))
(setq c1 (osnap p1 "cen"))
(setq c2 (osnap p2 "cen"))
(setq d1 (distance c1 c2))
(setq a1 (angle c1 c2))
(setq r1 (distance p1 c1))
(setq r2 (distance p2 c2))
(if (= (read(rtos r1 2 8)) (read(rtos r2 2 8)))
 (progn 
  (setq a2 (angle c1 p1))
  (if (< a2 0.0) (setq a2 (+ a2 (* 2 pi))))
  (if (and (> (- a2 a1) 0.0) (< (- a2 a1) pi))
   (setq a2 (+ a1 (/ pi 2))))
  (if (and (> (- a2 a1) pi) (< (- a2 a1) (* 2 pi)))
   (setq a2 (+ a1 (/ (* 3 pi) 2))))
  (setq p4 (polar c1 a2 r1))
  (command "line" p4 "tan" p2 "")
 )
 (progn
(setq p3 (polar c1 a1 
 (* (/ d1 (1- (/ r1 r2))) (/ r1 r2))))
(command "line" p3 "tan" p2 "tan" p1 "")
(command "erase" p3 "")
 ))
)
;
;  C:STAN draws "straight tangents" between two circles of
;any radius, or a line which is tangent to two circles which
;does not cross the imaginary line between the circle 
;centers.  See the function CTAN to draw tangents to two
;circles which cross the line between their centers.
;
;  The function prompts the user to point to the edge of
;the circles.  The picked points should be the "best guess"
;points.
;
;  The function works on the geometric principle that the
;tantent line to two unequal circles intersects a line between
;the circle centers, and this intersection can be located.
;Thus the STAN function finds this intersection, draws a
;tangent line to one circle and then the next circle using
;"osnap tangent".  The line segment from the intersection
;to the first circle is then erased.  If the circles chosen
;have almost equal radii, then the intersection point will
;be off the screen and might not be erased.  If this is the case
;it is a simple matter to erase the extra line after the
;function is done.
;
;  If the circles chosen have equal radii, then the STAN 
;function does not follow the above procedure.  It draws
;the tangent line by finding points on each circle which
;are perpendicular to the line beteween the circle centers
;and connecting with a line.
;
;  The STAN (straight tangent), and CTAN (cross tangent)
;functions can be used to connect any circles with any
;combination of tangent lines.
